'_______________________________________
'             A R R A Y L I S T   D E M O
'                       Ron Kessler
'_______________________________________

'This demo shows how to use the ArrayList object to hold any type of data/object. It automatically
'adjusts its size when more items are added.

'This is a great replacement for a data array because it has Add & remove methods as well as a binary
'search method that will search the entire collection and return the index number of where the item 
'was found...all without using a loop.

'This also shows how to do a case-insensitive search using the "CaseInsensitiveComparer" object.
'Items are stored in the list box for reference.Type in an item to search for and if found, it will
'return the index number of the item inside the ArrayList collection object.

Public Class frmMain


    Private Sub btnSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSearch.Click

        '---create the ArrayList
        Dim firstList As New ArrayList
        Dim myItem As String = String.Empty             'scratch variable

        '---now cycle through the list box items and add them to the ArrayList. I sorted the listbox by the way!
        For Each myItem In lstFirstList.Items
            firstList.Add(myItem.ToString)
        Next


        '---define item to find
        Dim itemToFind As String = txtSearch.Text.Trim

        '---do a search and return the index number of the item. An index of -1 means not found.
        Dim indexNum As Integer = firstList.BinarySearch(itemToFind, New CaseInsensitiveComparer())


        If indexNum > 0 Then
            MessageBox.Show("Found at Index " & indexNum, "ArrayList Demo", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            MessageBox.Show("Not Found", "ArrayList Demo", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

    End Sub

End Class
